#include <math.h>
#include <stdio.h>
#include <stdlib.h>

void general_one_to_all_bc (int p, int my_id, int source) {
  int my_virtual_id;
  int mask;
  int d = ceil(log2(p));
  int i;

  my_virtual_id = (my_id + (p - source)) % p;
  mask = (1 << d) - 1;

  for (i = d-1; i >= 0; i--) {
    mask ^= (1 << i);

    if ((my_virtual_id & mask) == 0) {
      if ((my_virtual_id & (1 << i)) == 0) {
	int virtual_dest = my_virtual_id ^ (1 << i);

	if (virtual_dest < p)
	  printf("Message sent to process %d\n", (virtual_dest + source) % p);
	else
	  printf("doing nothing\n");
      } else {
	int virtual_source = my_virtual_id ^ (1 << i);
	printf("Message received from process %d\n", (virtual_source + source) % p);
      }
    } else {
      printf("doing nothing\n");
    }
  }
}

int main (int argc, char * argv[]) {
  int my_id;
  int p;
  int source;

  if (argc < 2) {
    fprintf(stderr, "usage: %s id processes [source]\n", argv[0]);
    exit(EXIT_FAILURE);
  }

  my_id = atoi(argv[1]);
  p = atoi(argv[2]);
  source = argc > 3 ? atoi(argv[3]) : 0;

  if (my_id >= p || source >= p) {
    fprintf(stderr,
	    "%s %d too large for %d processes\n",
	    my_id >= p ? "rank" : "source",
	    my_id, p);
    exit(EXIT_FAILURE);
  }

  printf("doing broadcast rank %d out of %d processes with source %d\n",
	 my_id, p, source);
  general_one_to_all_bc(p, my_id, source);
  puts("");

  exit(EXIT_SUCCESS);
}
