#include <math.h>
#include <stdio.h>
#include <stdlib.h>

void general_all_to_one_reduce (int p, int my_id) {
  int mask;
  int d = ceil(log2(p));
  int i;

  mask = 0;

  for (i = d-1; i >= 0; i--) {
    if ((my_id & mask) == 0) {
      if ((my_id & (1 << i)) != 0) {
	int msg_destination = my_id ^ (1 << i);
	printf("Message sent to process %d\n", msg_destination);
      } else {
	int msg_source = my_id ^ (1 << i);

	if (msg_source < p)
	  printf("Message received from process %d\n", msg_source);
	else
	  printf("doing nothing\n");
      }
    } else {
      printf("doing nothing\n");
    }

    mask ^= (1 << i);
  }
}

int main (int argc, char * argv[]) {
  int my_id;
  int p;

  if (argc < 2) {
    fprintf(stderr, "usage: %s id processes\n", argv[0]);
    exit(EXIT_FAILURE);
  }

  my_id = atoi(argv[1]);
  p = atoi(argv[2]);

  if (my_id >= p) {
    fprintf(stderr,
	    "rank %d too large for %d processes\n",
	    my_id, p);
    exit(EXIT_FAILURE);
  }

  printf("doing reduce rank %d out of %d processes\n",
	 my_id, p);
  general_all_to_one_reduce(p, my_id);
  puts("");

  exit(EXIT_SUCCESS);
}
